<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <div class="update-service-page">
        <p>
            <a href="/services/{{ .Form.Name }}" class="button--link"
                >{{ svg "icon-chevron-left" "icon--inline" }}
                {{ i18n "Back" }}</a
            >
        </p>

        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}

        {{ if ne .Form.Action "delete-service" }}
            <form
                hx-post="/services/{{ .Form.Name }}/edit"
                hx-target="body"
                hx-swap="outerHTML"
                action="/services/{{ .Form.Name }}/edit"
                method="post"
                autocomplete="off"
                class="update-service-page__form"
                hx-disabled-elt="button[type=submit]"
            >
                <input
                    type="hidden"
                    name="csrfToken"
                    value="{{ .BaseAuthenticatedPage.CsrfToken }}"
                />

                <fieldset class="update-service-page__form-actions">
                    <button type="submit" class="button--primary">
                        {{ i18n "Edit" }}
                    </button>

                    <button
                        type="submit"
                        class="button--danger"
                        name="action"
                        value="delete"
                        onclick="window.ConfirmDeleteModal.showModal();return false;"
                    >
                        {{ svg "icon-delete-bin" "icon--inline" }}
                        {{ i18n "Remove" }}
                    </button>
                </fieldset>

                <fieldset>
                    <label>
                        <span>{{ i18n "Name" }}</span>
                        <input
                            class="input--large"
                            type="text"
                            name="name"
                            value="{{ .Form.Name }}"
                            disabled
                        />
                    </label>

                    <label>
                        <span>{{ i18n "Endpoint URL" }}</span>
                        <small
                            >{{ i18n "This endpoint must be able to serve requests at the endpoint URL ending with /" }}</small
                        >
                        <input
                            class="input--large"
                            type="text"
                            name="endpointURL"
                            value="{{ .Form.EndpointURL }}"
                            required
                            pattern="^(https|http):\/\/\S+$"
                            oninvalid="this.setCustomValidity('{{ i18n "Endpoint URL must be a valid URL including the http(s)" }}')"
                            oninput="this.setCustomValidity('')"
                        />
                    </label>

                    <label for="inwayAddress">
                        {{ i18n "Inway" }}
                    </label>
                    <div class="select">
                        <select name="inwayAddress" id="inwayAddress">
                            {{ range $inwayAddress := $.InwayAddresses }}
                                <option value="{{ $inwayAddress }}">
                                    {{ $inwayAddress }}
                                </option>
                            {{ end }}
                        </select>
                    </div>
                </fieldset>
            </form>
        {{ end }}
    </div>
    {{ block "confirm-delete-modal" . }}{{ end }}
{{ end }}
{{ define "confirm-delete-modal" }}
    <dialog id="ConfirmDeleteModal" class="modal">
        <div class="modal__content">
            <header class="modal__header">
                <h1 class="modal__header__title">
                    {{ i18n "Remove Service" }}
                </h1>
                <form>
                    <button
                        type="submit"
                        value="cancel"
                        formmethod="dialog"
                        class="modal__header__close"
                    >
                        {{ svg "icon-close" "modal__header__close-icon" }}
                    </button>
                </form>
            </header>
            <div class="modal__body">
                <p>
                    {{ i18n "Existing connections to this Service will no longer work once this Service has been removed!" }}
                </p>
                <p>
                    {{ i18n "Are you sure you want to remove the Service?" }}
                </p>

                <form
                    class="modal__footer"
                    action="/services/{{ .Form.Name }}/edit"
                    method="post"
                >
                    <input
                        type="hidden"
                        name="csrfToken"
                        value="{{ .BaseAuthenticatedPage.CsrfToken }}"
                    />
                    <button
                        type="submit"
                        class="button--secondary"
                        formmethod="dialog"
                        autofocus
                    >
                        {{ i18n "Cancel" }}
                    </button>

                    <button
                        class="button--primary"
                        type="submit"
                        name="action"
                        value="delete-service"
                    >
                        {{ i18n "Remove" }}
                    </button>
                </form>
            </div>
        </div>
    </dialog>
{{ end }}
